--- xpdf-3.02/splash/Splash.cc
+++ xpdf-3.02/splash/Splash.cc
@@ -1912,7 +1912,7 @@
   xq = w % scaledWidth;
 
   // allocate pixel buffer
-  pixBuf = (SplashColorPtr)gmalloc((yp + 1) * w);
+  pixBuf = (SplashColorPtr)gmalloc(((SafeInt(yp) + SafeInt(1)) * SafeInt(w)).Int());
 
   // initialize the pixel pipe
   pipeInit(&pipe, 0, 0, state->fillPattern, NULL, state->fillAlpha,
@@ -2208,9 +2208,9 @@
   xq = w % scaledWidth;
 
   // allocate pixel buffers
-  colorBuf = (SplashColorPtr)gmalloc((yp + 1) * w * nComps);
+  colorBuf = (SplashColorPtr)gmalloc(((SafeInt(yp) + SafeInt(1)) * SafeInt(w) * SafeInt(nComps)).Int());
   if (srcAlpha) {
-    alphaBuf = (Guchar *)gmalloc((yp + 1) * w);
+    alphaBuf = (Guchar *)gmalloc(((SafeInt(yp) + SafeInt(1)) * SafeInt(w)).Int());
   } else {
     alphaBuf = NULL;
   }
@@ -3064,7 +3064,7 @@
     // draw the start cap
     pathOut->moveTo(pathIn->pts[i].x - wdy, pathIn->pts[i].y + wdx);
     if (i == subpathStart) {
-      firstPt = pathOut->length - 1;
+      firstPt = pathOut->length.Int() - 1;
     }
     if (first && !closed) {
       switch (state->lineCap) {
@@ -3099,7 +3099,7 @@
     }
 
     // draw the left side of the segment rectangle
-    left2 = pathOut->length - 1;
+    left2 = pathOut->length.Int() - 1;
     pathOut->lineTo(pathIn->pts[i+1].x + wdy, pathIn->pts[i+1].y - wdx);
 
     // draw the end cap
@@ -3136,11 +3136,11 @@
     }
 
     // draw the right side of the segment rectangle
-    right2 = pathOut->length - 1;
+    right2 = pathOut->length.Int() - 1;
     pathOut->close();
 
     // draw the join
-    join2 = pathOut->length;
+    join2 = pathOut->length.Int();
     if (!last || closed) {
       crossprod = dx * dyNext - dy * dxNext;
       dotprod = -(dx * dxNext + dy * dyNext);
@@ -3254,10 +3254,10 @@
 	if (i >= subpathStart + 2) {
 	  pathOut->addStrokeAdjustHint(left1, right1, left0 + 1, right0);
 	  pathOut->addStrokeAdjustHint(left1, right1,
-				       join0, pathOut->length - 1);
+				       join0, pathOut->length.Int() - 1);
 	} else {
 	  pathOut->addStrokeAdjustHint(left1, right1,
-				       firstPt, pathOut->length - 1);
+				       firstPt, pathOut->length.Int() - 1);
 	}
 	if (closed) {
 	  pathOut->addStrokeAdjustHint(left1, right1, firstPt, leftFirst);
@@ -3266,7 +3266,7 @@
 	  pathOut->addStrokeAdjustHint(leftFirst, rightFirst,
 				       left1 + 1, right1);
 	  pathOut->addStrokeAdjustHint(leftFirst, rightFirst,
-				       join1, pathOut->length - 1);
+				       join1, pathOut->length.Int() - 1);
 	}
       }
     }
--- xpdf-3.02/splash/SplashBitmap.cc
+++ xpdf-3.02/splash/SplashBitmap.cc
@@ -44,13 +44,13 @@
   }
   rowSize += rowPad - 1;
   rowSize -= rowSize % rowPad;
-  data = (SplashColorPtr)gmalloc(rowSize * height);
+  data = (SplashColorPtr)gmallocn(rowSize, height);
   if (!topDown) {
     data += (height - 1) * rowSize;
     rowSize = -rowSize;
   }
   if (alphaA) {
-    alpha = (Guchar *)gmalloc(width * height);
+    alpha = (Guchar *)gmallocn(width, height);
   } else {
     alpha = NULL;
   }
--- xpdf-3.02/splash/SplashClip.cc
+++ xpdf-3.02/splash/SplashClip.cc
@@ -55,7 +55,8 @@
   paths = NULL;
   flags = NULL;
   scanners = NULL;
-  length = size = 0;
+  length = 0;
+  size = 0;
 }
 
 SplashClip::SplashClip(SplashClip *clip) {
@@ -124,7 +125,8 @@
   paths = NULL;
   flags = NULL;
   scanners = NULL;
-  length = size = 0;
+  length = 0;
+  size = 0;
 
   if (x0 < x1) {
     xMin = x0;
--- xpdf-3.02/splash/SplashClip.h
+++ xpdf-3.02/splash/SplashClip.h
@@ -101,7 +101,8 @@
   SplashXPath **paths;
   Guchar *flags;
   SplashXPathScanner **scanners;
-  int length, size;
+  int length;
+  SafeInt size;
 };
 
 #endif
--- xpdf-3.02/splash/SplashFTFont.cc
+++ xpdf-3.02/splash/SplashFTFont.cc
@@ -157,7 +157,7 @@
   FT_Vector offset;
   FT_GlyphSlot slot;
   FT_UInt gid;
-  int rowSize;
+  SafeInt rowSize;
   Guchar *p, *q;
   int i;
 
@@ -210,14 +210,14 @@
   if (aa) {
     rowSize = bitmap->w;
   } else {
-    rowSize = (bitmap->w + 7) >> 3;
+    rowSize = (SafeInt(bitmap->w) + SafeInt(7)) >> 3;
   }
-  bitmap->data = (Guchar *)gmalloc(rowSize * bitmap->h);
+  bitmap->data = (Guchar *)gmallocn(rowSize, bitmap->h);
   bitmap->freeData = gTrue;
   for (i = 0, p = bitmap->data, q = slot->bitmap.buffer;
        i < bitmap->h;
-       ++i, p += rowSize, q += slot->bitmap.pitch) {
-    memcpy(p, q, rowSize);
+       ++i, p += rowSize.Int(), q += slot->bitmap.pitch) {
+    memcpy(p, q, rowSize.Int());
   }
 
   return gTrue;
--- xpdf-3.02/splash/SplashFTFontEngine.cc
+++ xpdf-3.02/splash/SplashFTFontEngine.cc
@@ -91,7 +91,7 @@
 						GBool deleteFile) {
   FoFiType1C *ff;
   Gushort *cidToGIDMap;
-  int nCIDs;
+  SafeInt nCIDs;
   SplashFontFile *ret;
 
   // check for a CFF font
@@ -106,7 +106,7 @@
     nCIDs = 0;
   }
   ret = SplashFTFontFile::loadCIDFont(this, idA, fileName, deleteFile,
-				      cidToGIDMap, nCIDs);
+				      cidToGIDMap, nCIDs.Int());
   if (!ret) {
     gfree(cidToGIDMap);
   }
@@ -119,7 +119,7 @@
   FoFiTrueType *ff;
   GBool isCID;
   Gushort *cidToGIDMap;
-  int nCIDs;
+  SafeInt nCIDs;
   SplashFontFile *ret;
 
   cidToGIDMap = NULL;
@@ -134,7 +134,7 @@
     }
   }
   ret = SplashFTFontFile::loadCIDFont(this, idA, fileName, deleteFile,
-				      cidToGIDMap, nCIDs);
+				      cidToGIDMap, nCIDs.Int());
   if (!ret) {
     gfree(cidToGIDMap);
   }
--- xpdf-3.02/splash/SplashFont.cc
+++ xpdf-3.02/splash/SplashFont.cc
@@ -78,7 +78,7 @@
   cacheTags = (SplashFontCacheTag *)gmallocn(cacheSets * cacheAssoc,
 					     sizeof(SplashFontCacheTag));
   for (i = 0; i < cacheSets * cacheAssoc; ++i) {
-    cacheTags[i].mru = i & (cacheAssoc - 1);
+    cacheTags[i].mru = i & (cacheAssoc.Int() - 1);
   }
 }
 
@@ -106,7 +106,7 @@
   }
 
   // check the cache
-  i = (c & (cacheSets - 1)) * cacheAssoc;
+  i = (c & (cacheSets.Int() - 1)) * cacheAssoc.Int();
   for (j = 0; j < cacheAssoc; ++j) {
     if ((cacheTags[i+j].mru & 0x80000000) &&
 	cacheTags[i+j].c == c &&
@@ -151,7 +151,7 @@
   }
   p = NULL; // make gcc happy
   for (j = 0; j < cacheAssoc; ++j) {
-    if ((cacheTags[i+j].mru & 0x7fffffff) == cacheAssoc - 1) {
+    if ((cacheTags[i+j].mru & 0x7fffffff) == cacheAssoc.Int() - 1) {
       cacheTags[i+j].mru = 0x80000000;
       cacheTags[i+j].c = c;
       cacheTags[i+j].xFrac = (short)xFrac;
--- xpdf-3.02/splash/SplashFont.h
+++ xpdf-3.02/splash/SplashFont.h
@@ -97,8 +97,8 @@
     cacheTags;
   int glyphW, glyphH;		// size of glyph bitmaps
   int glyphSize;		// size of glyph bitmaps, in bytes
-  int cacheSets;		// number of sets in cache
-  int cacheAssoc;		// cache associativity (glyphs per set)
+  SafeInt cacheSets;		// number of sets in cache
+  SafeInt cacheAssoc;		// cache associativity (glyphs per set)
 };
 
 #endif
--- xpdf-3.02/splash/SplashPath.cc
+++ xpdf-3.02/splash/SplashPath.cc
@@ -44,13 +44,13 @@
   size = path->size;
   pts = (SplashPathPoint *)gmallocn(size, sizeof(SplashPathPoint));
   flags = (Guchar *)gmallocn(size, sizeof(Guchar));
-  memcpy(pts, path->pts, length * sizeof(SplashPathPoint));
-  memcpy(flags, path->flags, length * sizeof(Guchar));
+  memcpy(pts, path->pts, length.Int() * sizeof(SplashPathPoint));
+  memcpy(flags, path->flags, length.Int() * sizeof(Guchar));
   curSubpath = path->curSubpath;
   if (path->hints) {
     hintsLength = hintsSize = path->hintsLength;
     hints = (SplashPathHint *)gmallocn(hintsSize, sizeof(SplashPathHint));
-    memcpy(hints, path->hints, hintsLength * sizeof(SplashPathHint));
+    memcpy(hints, path->hints, hintsLength.Int() * sizeof(SplashPathHint));
   } else {
     hints = NULL;
   }
@@ -79,11 +79,11 @@
 void SplashPath::append(SplashPath *path) {
   int i;
 
-  curSubpath = length + path->curSubpath;
-  grow(path->length);
+  curSubpath = length.Int() + path->curSubpath;
+  grow(path->length.Int());
   for (i = 0; i < path->length; ++i) {
-    pts[length] = path->pts[i];
-    flags[length] = path->flags[i];
+    pts[length.Int()] = path->pts[i];
+    flags[length.Int()] = path->flags[i];
     ++length;
   }
 }
@@ -93,10 +93,10 @@
     return splashErrBogusPath;
   }
   grow(1);
-  pts[length].x = x;
-  pts[length].y = y;
-  flags[length] = splashPathFirst | splashPathLast;
-  curSubpath = length++;
+  pts[length.Int()].x = x;
+  pts[length.Int()].y = y;
+  flags[length.Int()] = splashPathFirst | splashPathLast;
+  curSubpath = (length++).Int();
   return splashOk;
 }
 
@@ -104,11 +104,11 @@
   if (noCurrentPoint()) {
     return splashErrNoCurPt;
   }
-  flags[length-1] &= ~splashPathLast;
+  flags[(length-1).Int()] &= ~splashPathLast;
   grow(1);
-  pts[length].x = x;
-  pts[length].y = y;
-  flags[length] = splashPathLast;
+  pts[length.Int()].x = x;
+  pts[length.Int()].y = y;
+  flags[length.Int()] = splashPathLast;
   ++length;
   return splashOk;
 }
@@ -119,19 +119,19 @@
   if (noCurrentPoint()) {
     return splashErrNoCurPt;
   }
-  flags[length-1] &= ~splashPathLast;
+  flags[(length-1).Int()] &= ~splashPathLast;
   grow(3);
-  pts[length].x = x1;
-  pts[length].y = y1;
-  flags[length] = splashPathCurve;
+  pts[length.Int()].x = x1;
+  pts[length.Int()].y = y1;
+  flags[length.Int()] = splashPathCurve;
   ++length;
-  pts[length].x = x2;
-  pts[length].y = y2;
-  flags[length] = splashPathCurve;
+  pts[length.Int()].x = x2;
+  pts[length.Int()].y = y2;
+  flags[length.Int()] = splashPathCurve;
   ++length;
-  pts[length].x = x3;
-  pts[length].y = y3;
-  flags[length] = splashPathLast;
+  pts[length.Int()].x = x3;
+  pts[length.Int()].y = y3;
+  flags[length.Int()] = splashPathLast;
   ++length;
   return splashOk;
 }
@@ -140,28 +140,28 @@
   if (noCurrentPoint()) {
     return splashErrNoCurPt;
   }
-  if (curSubpath == length - 1 ||
-      pts[length - 1].x != pts[curSubpath].x ||
-      pts[length - 1].y != pts[curSubpath].y) {
+  if (curSubpath == length.Int() - 1 ||
+      pts[length.Int() - 1].x != pts[curSubpath].x ||
+      pts[length.Int() - 1].y != pts[curSubpath].y) {
     lineTo(pts[curSubpath].x, pts[curSubpath].y);
   }
   flags[curSubpath] |= splashPathClosed;
-  flags[length - 1] |= splashPathClosed;
-  curSubpath = length;
+  flags[length.Int() - 1] |= splashPathClosed;
+  curSubpath = length.Int();
   return splashOk;
 }
 
 void SplashPath::addStrokeAdjustHint(int ctrl0, int ctrl1,
 				     int firstPt, int lastPt) {
   if (hintsLength == hintsSize) {
-    hintsSize = hintsLength ? 2 * hintsLength : 8;
+    hintsSize = hintsLength.Int() ? 2 * hintsLength : 8;
     hints = (SplashPathHint *)greallocn(hints, hintsSize,
 					sizeof(SplashPathHint));
   }
-  hints[hintsLength].ctrl0 = ctrl0;
-  hints[hintsLength].ctrl1 = ctrl1;
-  hints[hintsLength].firstPt = firstPt;
-  hints[hintsLength].lastPt = lastPt;
+  hints[hintsLength.Int()].ctrl0 = ctrl0;
+  hints[hintsLength.Int()].ctrl1 = ctrl1;
+  hints[hintsLength.Int()].firstPt = firstPt;
+  hints[hintsLength.Int()].lastPt = lastPt;
   ++hintsLength;
 }
 
@@ -178,7 +178,7 @@
   if (noCurrentPoint()) {
     return gFalse;
   }
-  *x = pts[length - 1].x;
-  *y = pts[length - 1].y;
+  *x = pts[length.Int() - 1].x;
+  *y = pts[length.Int() - 1].y;
   return gTrue;
 }
--- xpdf-3.02/splash/SplashPath.h
+++ xpdf-3.02/splash/SplashPath.h
@@ -91,7 +91,7 @@
   void offset(SplashCoord dx, SplashCoord dy);
 
   // Get the points on the path.
-  int getLength() { return length; }
+  int getLength() { return length.Int(); }
   void getPoint(int i, double *x, double *y, Guchar *f)
     { *x = pts[i].x; *y = pts[i].y; *f = flags[i]; }
 
@@ -108,11 +108,11 @@
 
   SplashPathPoint *pts;		// array of points
   Guchar *flags;		// array of flags
-  int length, size;		// length/size of the pts and flags arrays
+  SafeInt length, size;		// length/size of the pts and flags arrays
   int curSubpath;		// index of first point in last subpath
 
   SplashPathHint *hints;	// list of hints
-  int hintsLength, hintsSize;
+  SafeInt hintsLength, hintsSize;
 
   friend class SplashXPath;
   friend class Splash;
--- xpdf-3.02/splash/SplashScreen.cc
+++ xpdf-3.02/splash/SplashScreen.cc
@@ -12,7 +12,6 @@
 
 #include <stdlib.h>
 #include <string.h>
-#include "gmem.h"
 #include "SplashMath.h"
 #include "SplashScreen.h"
 
@@ -61,7 +60,7 @@
     // size must be a power of 2
     for (size = 1; size < params->size; size <<= 1) ;
     mat = (Guchar *)gmallocn(size * size, sizeof(Guchar));
-    buildDispersedMatrix(size/2, size/2, 1, size/2, 1);
+    buildDispersedMatrix((size/2).Int(), (size/2).Int(), 1, (size/2).Int(), 1);
     break;
 
   case splashScreenClustered:
@@ -76,8 +75,8 @@
 
   case splashScreenStochasticClustered:
     // size must be at least 2*r
-    if (params->size < 2 * params->dotRadius) {
-      size = 2 * params->dotRadius;
+    if (SafeInt(params->size) < 2 * SafeInt(params->dotRadius)) {
+      size = 2 * SafeInt(params->dotRadius);
     } else {
       size = params->size;
     }
@@ -118,15 +117,15 @@
 					int delta, int offset) {
   if (delta == 0) {
     // map values in [1, size^2] --> [1, 255]
-    mat[i * size + j] = 1 + (254 * (val - 1)) / (size * size - 1);
+    mat[i * size.Int() + j] = 1 + (254 * (val - 1)) / (size.Int() * size.Int() - 1);
   } else {
     buildDispersedMatrix(i, j,
 			 val, delta / 2, 4*offset);
-    buildDispersedMatrix((i + delta) % size, (j + delta) % size,
+    buildDispersedMatrix((i + delta) % size.Int(), (j + delta) % size.Int(),
 			 val + offset, delta / 2, 4*offset);
-    buildDispersedMatrix((i + delta) % size, j,
+    buildDispersedMatrix((i + delta) % size.Int(), j,
 			 val + 2*offset, delta / 2, 4*offset);
-    buildDispersedMatrix((i + 2*delta) % size, (j + delta) % size,
+    buildDispersedMatrix((i + 2*delta) % size.Int(), (j + delta) % size.Int(),
 			 val + 3*offset, delta / 2, 4*offset);
   }
 }
@@ -135,14 +134,15 @@
   SplashCoord *dist;
   SplashCoord u, v, d;
   Guchar val;
-  int size2, x, y, x1, y1, i;
+  SafeInt size2;
+  int x, y, x1, y1, i;
 
   size2 = size >> 1;
 
   // initialize the threshold matrix
   for (y = 0; y < size; ++y) {
     for (x = 0; x < size; ++x) {
-      mat[y * size + x] = 0;
+      mat[y * size.Int() + x] = 0;
     }
   }
 
@@ -154,22 +154,22 @@
 	u = (SplashCoord)x + 0.5 - 0;
 	v = (SplashCoord)y + 0.5 - 0;
       } else {
-	u = (SplashCoord)x + 0.5 - (SplashCoord)size2;
-	v = (SplashCoord)y + 0.5 - (SplashCoord)size2;
+	u = (SplashCoord)x + 0.5 - (SplashCoord)size2.Int();
+	v = (SplashCoord)y + 0.5 - (SplashCoord)size2.Int();
       }
-      dist[y * size2 + x] = u*u + v*v;
+      dist[y * size2.Int() + x] = u*u + v*v;
     }
   }
   for (y = 0; y < size2; ++y) {
     for (x = 0; x < size2; ++x) {
       if (x < y) {
 	u = (SplashCoord)x + 0.5 - 0;
-	v = (SplashCoord)y + 0.5 - (SplashCoord)size2;
+	v = (SplashCoord)y + 0.5 - (SplashCoord)size2.Int();
       } else {
-	u = (SplashCoord)x + 0.5 - (SplashCoord)size2;
+	u = (SplashCoord)x + 0.5 - (SplashCoord)size2.Int();
 	v = (SplashCoord)y + 0.5 - 0;
       }
-      dist[(size2 + y) * size2 + x] = u*u + v*v;
+      dist[(size2.Int() + y) * size2.Int() + x] = u*u + v*v;
     }
   }
 
@@ -181,22 +181,22 @@
     d = -1;
     for (y = 0; y < size; ++y) {
       for (x = 0; x < size2; ++x) {
-	if (mat[y * size + x] == 0 &&
-	    dist[y * size2 + x] > d) {
+	if (mat[y * size.Int() + x] == 0 &&
+	    dist[y * size2.Int() + x] > d) {
 	  x1 = x;
 	  y1 = y;
-	  d = dist[y1 * size2 + x1];
+	  d = dist[y1 * size2.Int() + x1];
 	}
       }
     }
     // map values in [0, 2*size*size2-1] --> [1, 255]
-    val = 1 + (254 * (2*i)) / (2*size*size2 - 1);
-    mat[y1 * size + x1] = val;
-    val = 1 + (254 * (2*i+1)) / (2*size*size2 - 1);
-    if (y1 < size2) {
-      mat[(y1 + size2) * size + x1 + size2] = val;
+    val = 1 + (254 * (2*i)) / (2*size.Int()*size2.Int() - 1);
+    mat[y1 * size.Int() + x1] = val;
+    val = 1 + (254 * (2*i+1)) / (2*size.Int()*size2.Int() - 1);
+    if (y1 < size2.Int()) {
+      mat[(y1 + size2.Int()) * size.Int() + x1 + size2.Int()] = val;
     } else {
-      mat[(y1 - size2) * size + x1 + size2] = val;
+      mat[(y1 - size2.Int()) * size.Int() + x1 + size2.Int()] = val;
     }
   }
 
@@ -208,10 +208,10 @@
   int dx0, dx1, dx, dy0, dy1, dy;
 
   dx0 = abs(x0 - x1);
-  dx1 = size - dx0;
+  dx1 = size.Int() - dx0;
   dx = dx0 < dx1 ? dx0 : dx1;
   dy0 = abs(y0 - y1);
-  dy1 = size - dy0;
+  dy1 = size.Int() - dy0;
   dy = dy0 < dy1 ? dy0 : dy1;
   return dx * dx + dy * dy;
 }
@@ -222,7 +222,7 @@
 // Hardcopy, and Graphic Arts IV, SPIE Vol. 3648, pp. 496-505, 1999.
 void SplashScreen::buildSCDMatrix(int r) {
   SplashScreenPoint *dots, *pts;
-  int dotsLen, dotsSize;
+  SafeInt dotsLen, dotsSize;
   char *tmpl;
   char *grid;
   int *region, *dist;
@@ -242,7 +242,7 @@
     }
   }
   for (i = 0; i < size * size; ++i) {
-    j = i + (int)((double)(size * size - i) *
+    j = i + (int)((double)(size.Int() * size.Int() - i) *
 		  (double)rand() / ((double)RAND_MAX + 1.0));
     x = pts[i].x;
     y = pts[i].y;
@@ -253,7 +253,7 @@
   }
 
   // construct the circle template
-  tmpl = (char *)gmallocn((r+1)*(r+1), sizeof(char));
+  tmpl = (char *)gmallocn((SafeInt(r)+SafeInt(1))*(SafeInt(r)+SafeInt(1)), sizeof(char));
   for (y = 0; y <= r; ++y) {
     for (x = 0; x <= r; ++x) {
       tmpl[y*(r+1) + x] = (x * y <= r * r) ? 1 : 0;
@@ -264,7 +264,7 @@
   grid = (char *)gmallocn(size * size, sizeof(char));
   for (y = 0; y < size; ++y) {
     for (x = 0; x < size; ++x) {
-      grid[y*size + x] = 0;
+      grid[y*size.Int() + x] = 0;
     }
   }
 
@@ -272,27 +272,27 @@
   dotsLen = 0;
   dotsSize = 32;
   dots = (SplashScreenPoint *)gmallocn(dotsSize, sizeof(SplashScreenPoint));
-  for (i = 0; i < size * size; ++i) {
+  for (i = 0; i < size.Int() * size.Int(); ++i) {
     x = pts[i].x;
     y = pts[i].y;
-    if (!grid[y*size + x]) {
+    if (!grid[y*size.Int() + x]) {
       if (dotsLen == dotsSize) {
 	dotsSize *= 2;
 	dots = (SplashScreenPoint *)greallocn(dots, dotsSize,
 					      sizeof(SplashScreenPoint));
       }
-      dots[dotsLen++] = pts[i];
+      dots[(dotsLen++).Int()] = pts[i];
       for (yy = 0; yy <= r; ++yy) {
-	y0 = (y + yy) % size;
-	y1 = (y - yy + size) % size;
+	y0 = (y + yy) % size.Int();
+	y1 = (y - yy + size.Int()) % size.Int();
 	for (xx = 0; xx <= r; ++xx) {
 	  if (tmpl[yy*(r+1) + xx]) {
-	    x0 = (x + xx) % size;
-	    x1 = (x - xx + size) % size;
-	    grid[y0*size + x0] = 1;
-	    grid[y0*size + x1] = 1;
-	    grid[y1*size + x0] = 1;
-	    grid[y1*size + x1] = 1;
+	    x0 = (x + xx) % size.Int();
+	    x1 = (x - xx + size.Int()) % size.Int();
+	    grid[y0*size.Int() + x0] = 1;
+	    grid[y0*size.Int() + x1] = 1;
+	    grid[y1*size.Int() + x0] = 1;
+	    grid[y1*size.Int() + x1] = 1;
 	  }
 	}
       }
@@ -316,17 +316,17 @@
 	  dMin = d;
 	}
       }
-      region[y*size + x] = iMin;
-      dist[y*size + x] = dMin;
+      region[y*size.Int() + x] = iMin;
+      dist[y*size.Int() + x] = dMin;
     }
   }
 
   // compute threshold values
   for (i = 0; i < dotsLen; ++i) {
     n = 0;
-    for (y = 0; y < size; ++y) {
-      for (x = 0; x < size; ++x) {
-	if (region[y*size + x] == i) {
+    for (y = 0; y < size.Int(); ++y) {
+      for (x = 0; x < size.Int(); ++x) {
+	if (region[y*size.Int() + x] == i) {
 	  pts[n].x = x;
 	  pts[n].y = y;
 	  pts[n].dist = distance(dots[i].x, dots[i].y, x, y);
@@ -337,7 +337,7 @@
     qsort(pts, n, sizeof(SplashScreenPoint), &cmpDistances);
     for (j = 0; j < n; ++j) {
       // map values in [0 .. n-1] --> [255 .. 1]
-      mat[pts[j].y * size + pts[j].x] = 255 - (254 * j) / (n - 1);
+      mat[pts[j].y * size.Int() + pts[j].x] = 255 - (254 * j) / (n - 1);
     }
   }
 
@@ -351,7 +351,7 @@
 SplashScreen::SplashScreen(SplashScreen *screen) {
   size = screen->size;
   mat = (Guchar *)gmallocn(size * size, sizeof(Guchar));
-  memcpy(mat, screen->mat, size * size * sizeof(Guchar));
+  memcpy(mat, screen->mat, (size * size).Int() * sizeof(Guchar));
   minVal = screen->minVal;
   maxVal = screen->maxVal;
 }
@@ -369,13 +369,13 @@
   if (value >= maxVal) {
     return 1;
   }
-  if ((xx = x % size) < 0) {
+  if ((xx = x % size.Int()) < 0) {
     xx = -xx;
   }
-  if ((yy = y % size) < 0) {
+  if ((yy = y % size.Int()) < 0) {
     yy = -yy;
   }
-  return value < mat[yy * size + xx] ? 0 : 1;
+  return value < mat[yy * size.Int() + xx] ? 0 : 1;
 }
 
 GBool SplashScreen::isStatic(Guchar value) {
--- xpdf-3.02/splash/SplashScreen.h
+++ xpdf-3.02/splash/SplashScreen.h
@@ -14,11 +14,14 @@
 #endif
 
 #include "SplashTypes.h"
+#include "gmem.h"
 
 //------------------------------------------------------------------------
 // SplashScreen
 //------------------------------------------------------------------------
 
+class SafeInt;
+
 class SplashScreen {
 public:
 
@@ -46,7 +49,7 @@
   void buildSCDMatrix(int r);
 
   Guchar *mat;			// threshold matrix
-  int size;			// size of the threshold matrix
+  SafeInt size;			// size of the threshold matrix
   Guchar minVal;		// any pixel value below minVal generates
 				//   solid black
   Guchar maxVal;		// any pixel value above maxVal generates
--- xpdf-3.02/splash/SplashT1Font.cc
+++ xpdf-3.02/splash/SplashT1Font.cc
@@ -183,7 +183,8 @@
 GBool SplashT1Font::makeGlyph(int c, int xFrac, int yFrac,
 			      SplashGlyphBitmap *bitmap) {
   GLYPH *glyph;
-  int n, i;
+  int i;
+  SafeInt n;
 
   if (aa) {
     glyph = T1_AASetChar(t1libID, c, size, NULL);
@@ -203,7 +204,7 @@
     bitmap->data = (Guchar *)glyph->bits;
     bitmap->freeData = gFalse;
   } else {
-    n = bitmap->h * ((bitmap->w + 7) >> 3);
+    n = SafeInt(bitmap->h) * ((SafeInt(bitmap->w) + SafeInt(7)) >> SafeInt(3));
     bitmap->data = (Guchar *)gmalloc(n);
     for (i = 0; i < n; ++i) {
       bitmap->data[i] = bitReverse[glyph->bits[i] & 0xff];
--- xpdf-3.02/splash/SplashT1FontFile.cc
+++ xpdf-3.02/splash/SplashT1FontFile.cc
@@ -31,7 +31,7 @@
   int t1libIDA;
   char **encTmp;
   char *encStrTmp;
-  int encStrSize;
+  SafeInt encStrSize;
   char *encPtr;
   int i;
 
@@ -45,7 +45,7 @@
   encStrSize = 0;
   for (i = 0; i < 256; ++i) {
     if (encA[i]) {
-      encStrSize += strlen(encA[i]) + 1;
+      encStrSize += SafeInt(strlen(encA[i])) + SafeInt(1);
     }
   }
   encTmp = (char **)gmallocn(257, sizeof(char *));
--- xpdf-3.02/splash/SplashXPath.cc
+++ xpdf-3.02/splash/SplashXPath.cc
@@ -147,7 +147,7 @@
       xsp = x0;
       ysp = y0;
       curSubpath = i;
-      curSubpathX = length;
+      curSubpathX = length.Int();
       ++i;
 
     } else {
@@ -236,7 +236,7 @@
   length = xPath->length;
   size = xPath->size;
   segs = (SplashXPathSeg *)gmallocn(size, sizeof(SplashXPathSeg));
-  memcpy(segs, xPath->segs, length * sizeof(SplashXPathSeg));
+  memcpy(segs, xPath->segs, length.Int() * sizeof(SplashXPathSeg));
 }
 
 SplashXPath::~SplashXPath() {
@@ -344,51 +344,51 @@
 			     SplashCoord x1, SplashCoord y1,
 			     GBool first, GBool last, GBool end0, GBool end1) {
   grow(1);
-  segs[length].x0 = x0;
-  segs[length].y0 = y0;
-  segs[length].x1 = x1;
-  segs[length].y1 = y1;
-  segs[length].flags = 0;
+  segs[length.Int()].x0 = x0;
+  segs[length.Int()].y0 = y0;
+  segs[length.Int()].x1 = x1;
+  segs[length.Int()].y1 = y1;
+  segs[length.Int()].flags = 0;
   if (first) {
-    segs[length].flags |= splashXPathFirst;
+    segs[length.Int()].flags |= splashXPathFirst;
   }
   if (last) {
-    segs[length].flags |= splashXPathLast;
+    segs[length.Int()].flags |= splashXPathLast;
   }
   if (end0) {
-    segs[length].flags |= splashXPathEnd0;
+    segs[length.Int()].flags |= splashXPathEnd0;
   }
   if (end1) {
-    segs[length].flags |= splashXPathEnd1;
+    segs[length.Int()].flags |= splashXPathEnd1;
   }
   if (y1 == y0) {
-    segs[length].dxdy = segs[length].dydx = 0;
-    segs[length].flags |= splashXPathHoriz;
+    segs[length.Int()].dxdy = segs[length.Int()].dydx = 0;
+    segs[length.Int()].flags |= splashXPathHoriz;
     if (x1 == x0) {
-      segs[length].flags |= splashXPathVert;
+      segs[length.Int()].flags |= splashXPathVert;
     }
   } else if (x1 == x0) {
-    segs[length].dxdy = segs[length].dydx = 0;
-    segs[length].flags |= splashXPathVert;
+    segs[length.Int()].dxdy = segs[length.Int()].dydx = 0;
+    segs[length.Int()].flags |= splashXPathVert;
   } else {
 #if USE_FIXEDPOINT
-    if (FixedPoint::divCheck(x1 - x0, y1 - y0, &segs[length].dxdy)) {
-      segs[length].dydx = (SplashCoord)1 / segs[length].dxdy;
+    if (FixedPoint::divCheck(x1 - x0, y1 - y0, &segs[length.Int()].dxdy)) {
+      segs[length.Int()].dydx = (SplashCoord)1 / segs[length.Int()].dxdy;
     } else {
-      segs[length].dxdy = segs[length].dydx = 0;
+      segs[length.Int()].dxdy = segs[length.Int()].dydx = 0;
       if (splashAbs(x1 - x0) > splashAbs(y1 - y0)) {
-	segs[length].flags |= splashXPathHoriz;
+	segs[length.Int()].flags |= splashXPathHoriz;
       } else {
-	segs[length].flags |= splashXPathVert;
+	segs[length.Int()].flags |= splashXPathVert;
       }
     }
 #else
-    segs[length].dxdy = (x1 - x0) / (y1 - y0);
-    segs[length].dydx = (SplashCoord)1 / segs[length].dxdy;
+    segs[length.Int()].dxdy = (x1 - x0) / (y1 - y0);
+    segs[length.Int()].dydx = (SplashCoord)1 / segs[length.Int()].dxdy;
 #endif
   }
   if (y0 > y1) {
-    segs[length].flags |= splashXPathFlip;
+    segs[length.Int()].flags |= splashXPathFlip;
   }
   ++length;
 }
@@ -434,5 +434,5 @@
 }
 
 void SplashXPath::sort() {
-  qsort(segs, length, sizeof(SplashXPathSeg), &cmpXPathSegs);
+  qsort(segs, length.Int(), sizeof(SplashXPathSeg), &cmpXPathSegs);
 }
--- xpdf-3.02/splash/SplashXPath.h
+++ xpdf-3.02/splash/SplashXPath.h
@@ -90,7 +90,7 @@
 		  GBool first, GBool last, GBool end0, GBool end1);
 
   SplashXPathSeg *segs;
-  int length, size;		// length and size of segs array
+  SafeInt length, size;		// length and size of segs array
 
   friend class SplashXPathScanner;
   friend class SplashClip;
--- xpdf-3.02/splash/SplashXPathScanner.cc
+++ xpdf-3.02/splash/SplashXPathScanner.cc
@@ -92,7 +92,8 @@
   interY = yMin - 1;
   xPathIdx = 0;
   inter = NULL;
-  interLen = interSize = 0;
+  interLen = 0;
+  interSize = 0;
 }
 
 SplashXPathScanner::~SplashXPathScanner() {
--- xpdf-3.02/splash/SplashXPathScanner.h
+++ xpdf-3.02/splash/SplashXPathScanner.h
@@ -81,7 +81,7 @@
 				//   computeIntersections
   SplashIntersect *inter;	// intersections array for <interY>
   int interLen;			// number of intersections in <inter>
-  int interSize;		// size of the <inter> array
+  SafeInt interSize;		// size of the <inter> array
 };
 
 #endif
--- xpdf-3.02/xpdf/Annot.cc
+++ xpdf-3.02/xpdf/Annot.cc
@@ -1437,7 +1437,7 @@
   Annot *annot;
   Object obj1;
   Ref ref;
-  int size;
+  SafeInt size;
   int i;
 
   annots = NULL;
--- xpdf-3.02/xpdf/Array.cc
+++ xpdf-3.02/xpdf/Array.cc
@@ -46,7 +46,7 @@
     }
     elems = (Object *)greallocn(elems, size, sizeof(Object));
   }
-  elems[length] = *elem;
+  elems[length.Int()] = *elem;
   ++length;
 }
 
--- xpdf-3.02/xpdf/Array.h
+++ xpdf-3.02/xpdf/Array.h
@@ -37,7 +37,7 @@
   int decRef() { return --ref; }
 
   // Get number of elements.
-  int getLength() { return length; }
+  int getLength() { return length.Int(); }
 
   // Add an element.
   void add(Object *elem);
@@ -50,8 +50,8 @@
 
   XRef *xref;			// the xref table for this PDF file
   Object *elems;		// array of elements
-  int size;			// size of <elems> array
-  int length;			// number of elements in array
+  SafeInt size;			// size of <elems> array
+  SafeInt length;		// number of elements in array
   int ref;			// reference count
 };
 
--- xpdf-3.02/xpdf/Catalog.cc
+++ xpdf-3.02/xpdf/Catalog.cc
@@ -38,7 +38,7 @@
   xref = xrefA;
   pages = NULL;
   pageRefs = NULL;
-  numPages = pagesSize = 0;
+  pagesSize = numPages = 0;
   baseURI = NULL;
 
   xref->getCatalog(&catDict);
@@ -219,7 +219,7 @@
 	pagesSize += 32;
 	pages = (Page **)greallocn(pages, pagesSize, sizeof(Page *));
 	pageRefs = (Ref *)greallocn(pageRefs, pagesSize, sizeof(Ref));
-	for (j = pagesSize - 32; j < pagesSize; ++j) {
+	for (j = (pagesSize - 32).Int(); j < pagesSize; ++j) {
 	  pages[j] = NULL;
 	  pageRefs[j].num = -1;
 	  pageRefs[j].gen = -1;
--- xpdf-3.02/xpdf/Catalog.h
+++ xpdf-3.02/xpdf/Catalog.h
@@ -79,7 +79,7 @@
   Page **pages;			// array of pages
   Ref *pageRefs;		// object ID for each page
   int numPages;			// number of pages
-  int pagesSize;		// size of pages array
+  SafeInt pagesSize;		// size of pages array
   Object dests;			// named destination dictionary
   Object nameTree;		// name tree
   GString *baseURI;		// base URI for URI-type links
--- xpdf-3.02/xpdf/CharCodeToUnicode.cc
+++ xpdf-3.02/xpdf/CharCodeToUnicode.cc
@@ -58,7 +58,8 @@
 							GString *collection) {
   FILE *f;
   Unicode *mapA;
-  CharCode size, mapLenA;
+  CharCode mapLenA;
+  SafeInt size;
   char buf[64];
   Unicode u;
   CharCodeToUnicode *ctu;
@@ -100,7 +101,8 @@
   FILE *f;
   Unicode *mapA;
   CharCodeToUnicodeString *sMapA;
-  CharCode size, oldSize, len, sMapSizeA, sMapLenA;
+  CharCode len, sMapLenA;
+  SafeInt size, oldSize, sMapSizeA;
   char buf[256];
   char *tok;
   Unicode u0;
@@ -116,7 +118,7 @@
 
   size = 4096;
   mapA = (Unicode *)gmallocn(size, sizeof(Unicode));
-  memset(mapA, 0, size * sizeof(Unicode));
+  memset(mapA, 0, size.Int() * sizeof(Unicode));
   len = 0;
   sMapA = NULL;
   sMapSizeA = sMapLenA = 0;
@@ -153,7 +155,7 @@
 	size *= 2;
       }
       mapA = (Unicode *)greallocn(mapA, size, sizeof(Unicode));
-      memset(mapA + oldSize, 0, (size - oldSize) * sizeof(Unicode));
+      memset(mapA + oldSize.Int(), 0, (size - oldSize).Int() * sizeof(Unicode));
     }
     if (n == 1) {
       mapA[u0] = uBuf[0];
@@ -178,7 +180,7 @@
   fclose(f);
 
   ctu = new CharCodeToUnicode(fileName->copy(), mapA, len, gTrue,
-			      sMapA, sMapLenA, sMapSizeA);
+			      sMapA, sMapLenA, sMapSizeA.Int());
   gfree(mapA);
   return ctu;
 }
@@ -319,7 +321,7 @@
 
   if (code >= mapLen) {
     oldLen = mapLen;
-    mapLen = (code + 256) & ~255;
+    mapLen = (SafeInt(code) + 256).Int() & ~255;
     map = (Unicode *)greallocn(map, mapLen, sizeof(Unicode));
     for (i = oldLen; i < mapLen; ++i) {
       map[i] = 0;
@@ -362,7 +364,7 @@
     map[i] = 0;
   }
   sMap = NULL;
-  sMapLen = sMapSize = 0;
+  sMapSize = sMapLen = 0;
   refCnt = 1;
 #if MULTITHREADED
   gInitMutex(&mutex);
--- xpdf-3.02/xpdf/CharCodeToUnicode.h
+++ xpdf-3.02/xpdf/CharCodeToUnicode.h
@@ -87,7 +87,8 @@
   Unicode *map;
   CharCode mapLen;
   CharCodeToUnicodeString *sMap;
-  int sMapLen, sMapSize;
+  int sMapLen;
+  SafeInt sMapSize;
   int refCnt;
 #if MULTITHREADED
   GMutex mutex;
--- xpdf-3.02/xpdf/Decrypt.cc
+++ xpdf-3.02/xpdf/Decrypt.cc
@@ -113,7 +113,7 @@
   GBool ok;
 
   // generate file key
-  buf = (Guchar *)gmalloc(72 + fileID->getLength());
+  buf = (Guchar *)gmalloc((SafeInt(72) + SafeInt(fileID->getLength())).Int());
   if (userPassword) {
     len = userPassword->getLength();
     if (len < 32) {
--- xpdf-3.02/xpdf/Dict.h
+++ xpdf-3.02/xpdf/Dict.h
@@ -67,7 +67,7 @@
 
   XRef *xref;			// the xref table for this PDF file
   DictEntry *entries;		// array of entries
-  int size;			// size of <entries> array
+  SafeInt size;			// size of <entries> array
   int length;			// number of entries in dictionary
   int ref;			// reference count
 
